﻿using System;
using System.Runtime.InteropServices;

// ReSharper disable InconsistentNaming
// ReSharper disable FieldCanBeMadeReadOnly.Global

namespace DesignerSnapLinesDemo
{
  internal static class NativeMethods
  {
    #region Externals

[DllImport("gdi32.dll", CharSet = CharSet.Auto, SetLastError = true)]
public static extern bool DeleteObject(IntPtr hObject);

[DllImport("gdi32.dll", CharSet = CharSet.Auto)]
public static extern bool GetTextMetrics(IntPtr hdc, out TEXTMETRICW lptm);

[DllImport("gdi32.dll", CharSet = CharSet.Auto)]
public static extern IntPtr SelectObject(IntPtr hdc, IntPtr hgdiObj);

    #endregion

    #region Nested type: TEXTMETRICW

[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
public struct TEXTMETRICW
{
  public int tmHeight;

  public int tmAscent;

  public int tmDescent;

  public int tmInternalLeading;

  public int tmExternalLeading;

  public int tmAveCharWidth;

  public int tmMaxCharWidth;

  public int tmWeight;

  public int tmOverhang;

  public int tmDigitizedAspectX;

  public int tmDigitizedAspectY;

  public ushort tmFirstChar;

  public ushort tmLastChar;

  public ushort tmDefaultChar;

  public ushort tmBreakChar;

  public byte tmItalic;

  public byte tmUnderlined;

  public byte tmStruckOut;

  public byte tmPitchAndFamily;

  public byte tmCharSet;
}

    #endregion
  }
}
